#include "CivProjInpDbHelper.h"
#include "CivConnection.h"
#include "CivTableFields.h"
#include <algorithm>

CivProjInpDbHelper::CivProjInpDbHelper(const std::string& uri)
	:CivInpHelperAbs(uri)
{
	
}

CivProjInpDbHelper::~CivProjInpDbHelper()
{

}

void CivProjInpDbHelper::setProjCode(const std::string& projCode)
{
	mPorjCode = projCode;
}

void CivProjInpDbHelper::handlePump()
{
	// ˮӵĹܶ
}

bool CivProjInpDbHelper::getNode(CivNode& node)
{
	// ңڵ
	JunctionTable nodeTableFields;

	std::string sql = "select  \"code\",  \"\", \"߳\", \"ˮ\", \"ˮģʽ\", \"\",\"\" \
							from  \"ڵ\"   where\
							\"code\" not in(select det.\"code\" from \"\" as det where det.\"\" = '" + mPorjCode + "' and \"ͼ\" = 'ڵ' and \"\"=0)\
							union   select   \"code\",  \"\", \"߳\", \"ˮ\", \"ˮģʽ\", \"\",\"\" \
							from   \"ڵ\"  where    \"\" = '" + mPorjCode + "' ";

	if (!mDbConn->execSql(sql))
		return false;

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->queryResult(resultVector);

	// ҳڵͼ޸ĵֵ
	std::vector<std::map<std::string, std::string>> nodeDetailVec;
	auto iter = mDetailMap.find(PIPENODE);
	if (iter != mDetailMap.end())
		nodeDetailVec = iter->second;

	// ༭װ
	size_t total = resultVector.size();
	for (int i = 0; i < total; i++)
	{
		std::map<std::string, std::string> map = resultVector[i];
		CivNode::NodeTable nodeTable;

		std::string code = map.find(nodeTableFields.code)->second;
		std::string elev = map.find(nodeTableFields.elev)->second;
		std::string patternID = map.find(nodeTableFields.demandPattern)->second;
		std::string demand = map.find(nodeTableFields.baseDemand)->second;

		// codeƥ
		for (int i = 0; i < nodeDetailVec.size(); i++)
		{
			auto detailMap = nodeDetailVec[i];

			//code ƥ䣬һѭ
			auto codeIter = detailMap.find(nodeTableFields.code);
			if (codeIter == detailMap.end())
				continue;

			// code ԭcode, 
			if (codeIter->second == code)
				continue;

			// ޸ĶӦֵ
			std::string attri = detailMap.find("")->second;
			std::string newValue = detailMap.find("ֵ")->second;
			if (attri == nodeTableFields.elev)
			{
				elev = newValue;
			}
			else if (attri == nodeTableFields.demandPattern)
			{
				patternID = newValue;
			}
			else if (attri == nodeTableFields.baseDemand)
			{
				demand = newValue;
			}

		}

		nodeTable.ID = map.find("")->second;
		nodeTable.Elev = elev;
		handleDelayPattern(demand, patternID, nodeTable.Demand, nodeTable.PatternId);

		node.addItem(nodeTable);
	}

	// ӴķŲĽڵ
	size_t size = mNodeVec.size();
	for (int i = 0; i < size; i++)
	{
		node.addItem(mNodeVec[i]);
	}
}

void CivProjInpDbHelper::sortProjDeatil()
{
	// ҷ޸ĵ
	std::string detailSql = "select detail.\"code\",detail.\"ͼ\",detail.\"\",detail.\"ԭֵ\",detail.\"ֵ\"\
		 from \"\" as detail where \"\"='" + mPorjCode +"' and \"\"=1";

	if (!mDbConn->execSql(detailSql))
		return;

	std::vector<std::map<std::string, std::string>> detailVec;
	mDbConn->queryResult(detailVec);

	size_t detailVecSize = detailVec.size();

	// 
	for (int i = 0; i < detailVecSize; i++)
	{
		std::map<std::string, std::string> tempMap = detailVec[i];
		std::string layerName = tempMap.find("ͼ")->second;

		mDetailMap[layerName].push_back(tempMap);
	}
}

std::string CivProjInpDbHelper::splicingConditions(const std::string& layer)
{
	std::string condition = "\"code\" not in(select  \"code\" from \"\" \
				where \"\" = '" + mPorjCode + "' and \"ͼ\" = '"+ layer +"' and \"\"=0)";

	return condition;
}

void CivProjInpDbHelper::handleValve()
{
	sortProjDeatil();
	handleValves2();
	return ;
}

bool CivProjInpDbHelper::getPipe(CivPipe& pipes)
{
	// ϴźˮòܶ
	for (int i = 0; i < mPipesVec.size(); i++)
	{
		pipes.addItem(mPipesVec[i]);
	}

	PipeTable pipeTable;

	std::string sql = "select  \"code\",\"\",\"ʼڵ\",\"ֹڵ\",\"ܳ\",\"ܾ\",\"Ħϵ\",\"ϵ\",\"ʼ״̬\"\
							 from \"ܶ\" \
							where \"from_layer\" not in('','','ˮ','ˮ') \
							and \"to_layer\" not in('','','ˮ','ˮ') \
							and \"code\" not in(select det.\"code\" from \"\" as det where det.\"\" = '"+mPorjCode+"' and \"ͼ\"='ܶ')\
							union select \
							\"code\",\"\",\"ʼڵ\",\"ֹڵ\",\"ܳ\",\"ܾ\",\"Ħϵ\",\"ϵ\",\"ʼ״̬\" from \"ܶ\" where \
							\"\" = '"+mPorjCode+"'";

	if (!mDbConn->execSql(sql))
		return false;

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->queryResult(resultVector);

	// ҳܶͼ޸ĵֵ
	std::vector<std::map<std::string, std::string>> lineDetailVec;
	auto iter = mDetailMap.find(PIPELINE);
	if (iter != mDetailMap.end())
		lineDetailVec = iter->second;

	size_t total = resultVector.size();
	for (int i = 0; i < total; i++)
	{
		CivPipe::PipesTable pipe;

		std::map<std::string, std::string> map = resultVector[i];

		std::string code = map.find("code")->second;
		pipe.ID = map.find(pipeTable.snNo)->second;
		pipe.Node1 = map.find(pipeTable.startPoint)->second;
		pipe.Node2 = map.find(pipeTable.endPoint)->second;
		pipe.Status = map.find(pipeTable.status)->second;

		std::string Length = map.find(pipeTable.length)->second;
		std::string Diameter = map.find(pipeTable.diameter)->second;
		std::string Roughness = map.find(pipeTable.friction)->second;
		std::string MinorLoss = map.find(pipeTable.localLoss)->second;

		for (int i = 0; i < lineDetailVec.size(); i++)
		{
			std::map<std::string, std::string>  detailMap = lineDetailVec[i];

			//code ƥ䣬һѭ
			auto codeIter = detailMap.find("code");
			if (codeIter == detailMap.end())
				continue;

			// code ԭcode, 
			if (codeIter->second != code)
				continue;

			// ޸ĶӦֵ
			std::string attri = detailMap.find("")->second;
			if (attri == pipeTable.length)
			{
				Length = detailMap.find("ֵ")->second;
			}
			else if (attri == pipeTable.diameter)
			{
				Diameter = detailMap.find("ֵ")->second;
			}
			else if (attri == pipeTable.friction)
			{
				Roughness = detailMap.find("ֵ")->second;
			}
			else if (attri == pipeTable.localLoss)
			{
				MinorLoss = detailMap.find("ֵ")->second;
			}
		}

		pipe.Length = Length;
		pipe.Diameter = Diameter;
		pipe.Roughness = Roughness;
		pipe.MinorLoss = MinorLoss;
		
		pipes.addItem(pipe);
	}
	
	return true;
}

bool CivProjInpDbHelper::getTank(CivTank& tanks)
{
	TankTable tankTable;
	std::string sql = "select \"code\",\"\",\"߳\",\"ʼˮλ\",\"ˮλ\",\"ˮλ\",\"ֱ\",\
		\"Сݻ\",\"ݻ\" from \"ˮ\"\
		where \"code\" not in(select det.\"code\" from \"\" as det\
		 where det.\"\" = '"+mPorjCode+"' and det.\"ͼ\" = 'ˮ') \
		union select  \"code\",\"\",\"߳\",\"ʼˮλ\",\"ˮλ\",\
			\"ˮλ\",\"ֱ\", \"Сݻ\",\"ݻ\" from \"ˮ\"\
		where \"\"='"+mPorjCode+"'";

	if (!mDbConn->execSql(sql))
		return false;

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->queryResult(resultVector);

	// ҳڵͼ޸ĵֵ
	std::vector<std::map<std::string, std::string>> tankDetailVec;
	auto iter = mDetailMap.find(PIPENODE);
	if (iter != mDetailMap.end())
		tankDetailVec = iter->second;

	size_t total = resultVector.size();
	for (int i = 0; i < total; i++)
	{
		CivTank::TankTable tank;
		std::map<std::string, std::string>map = resultVector[i];

		std::string code = map.find("code")->second;

		tank.ID = map.find(tankTable.sn)->second;
		std::string Elev = map.find(tankTable.elev)->second;
		std::string InitLevel = map.find(tankTable.initLevel)->second;
		std::string MinLevel = map.find(tankTable.minLevel)->second;
		std::string MaxLevel = map.find(tankTable.maxLevel)->second;
		std::string Diameter = map.find(tankTable.diametor)->second;
		std::string MinVol = map.find(tankTable.minVolume)->second;
		std::string VolCurve = map.find(tankTable.volumeCurve)->second;

		// codeƥ
		for (int i = 0; i < tankDetailVec.size(); i++)
		{
			auto detailMap = tankDetailVec[i];

			//code ƥ䣬һѭ
			auto codeIter = detailMap.find("code");
			if (codeIter == detailMap.end())
				continue;

			// code ԭcode, 
			if (codeIter->second == code)
				continue;

			// ޸ĶӦֵ
			std::string attri = detailMap.find("")->second;
			std::string newValue = detailMap.find("ֵ")->second;

			if (attri == tankTable.elev)
			{
				Elev = newValue;
			}
			else if (attri == tankTable.initLevel)
			{
				InitLevel = newValue;
			}
			else if (attri == tankTable.minLevel)
			{
				MinLevel = newValue;
			}
			else if (attri == tankTable.maxLevel)
			{
				MaxLevel = newValue;
			}
			else if (attri == tankTable.diametor)
			{
				Diameter = newValue;
			}
			else if (attri == tankTable.minVolume)
			{
				MinVol = newValue;
			}
			else if (attri == tankTable.volumeCurve)
			{
				VolCurve = newValue;
			}
		}

		tank.Elev = Elev;
		tank.InitLevel = InitLevel;
		tank.MinLevel = MinLevel;
		tank.MaxLevel = MaxLevel;
		tank.Diameter = Diameter;
		tank.MinVol = MinVol;
		tank.VolCurve = VolCurve;

		tanks.addItem(tank);
	}

	return true;
}

bool CivProjInpDbHelper::getValve(CivValve& valves)
{
	/*ValveTable vaveTable;
	std::vector<std::string> fields;

	fields.push_back(vaveTable.sn);
	fields.push_back(vaveTable.startPoint);
	fields.push_back(vaveTable.endPoint);
	fields.push_back(vaveTable.length);
	fields.push_back(vaveTable.type);
	fields.push_back(vaveTable.setting);
	fields.push_back(vaveTable.lossCoeff);

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->query(VALVE, fields, resultVector);
	mDbConn->query(PROJ_VALVE, fields, resultVector, mCondition);

	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivValve::ValveTable vave;
		std::map<std::string, std::string> map = resultVector[i];

		vave.ID = map.find(vaveTable.sn)->second;
		vave.Node1 = map.find(vaveTable.startPoint)->second;
		vave.Node2 = map.find(vaveTable.endPoint)->second;
		vave.Diameter = map.find(vaveTable.length)->second;
		vave.Type = map.find(vaveTable.type)->second;
		vave.Setting = map.find(vaveTable.setting)->second;
		vave.MinorLoss = map.find(vaveTable.lossCoeff)->second;

		valves.addItem(vave);
	}*/
	for (int i = 0; i < mValuvesVec.size(); i++)
	{
		valves.addItem(mValuvesVec[i]);
	}
	return true;
}

bool CivProjInpDbHelper::getPumps(CivPumps& pumps)
{
	PumpTable pmTable;

	std::vector<std::string> fields;	
	fields.push_back(pmTable.sn);
	fields.push_back(pmTable.startPoint);
	fields.push_back(pmTable.endPoint);
	fields.push_back(pmTable.headCurve);
	fields.push_back(pmTable.power);
	
	std::vector<std::map<std::string, std::string>> resultVector;
	std::string condition1 = splicingConditions(PUMP);
	mDbConn->query(PUMP, fields, resultVector, condition1);

	std::string condition2 = " \"\" = '" + mPorjCode + "'";
	mDbConn->query(PROJ_PUMP, fields, resultVector, condition2);

	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivPumps::PumpTable pump;
		std::map<std::string, std::string> map = resultVector[i];

		pump.ID = map.find(pmTable.sn)->second;
		pump.Node1 = map.find(pmTable.startPoint)->second;
		pump.Node2 = map.find(pmTable.endPoint)->second;
		std::string param = "Head 1";

		std::string curve = map.find(pmTable.headCurve)->second;
		if (curve != "")
			param = "head " + curve;

		std::string power = map.find(pmTable.power)->second;
		if (power != "")
			param.append(" power " + power);

		pump.Parameters = param;
		pumps.addItem(pump);
	}
	return true;
}

bool CivProjInpDbHelper::getReservoirs(CivReservoirs& reservoirs)
{
	ResourcesTable restemTable;

	std::string sql = "select \"code\",\"\",\"ˮͷ\",\"ˮͷģʽ\" from \"ˮ\" \
							where code not in(select \"code\" from \"\" \
							where \"\"='"+mPorjCode+"' and \"ͼ\"='ˮ' and \"\" =0) \
							union select  \"code\",\"\",\"ˮͷ\",\"ˮͷģʽ\" from \"ˮ\" where \"\" = '"+mPorjCode+"'";

	std::vector<std::map<std::string, std::string>> resultVector;

	if (!mDbConn->execSql(sql))
		return false;

	mDbConn->queryResult(resultVector);

	// ҳڵͼ޸ĵֵ
	std::vector<std::map<std::string, std::string>> resourceDetailVec;
	auto iter = mDetailMap.find(RESIVOIR);
	if (iter != mDetailMap.end())
		resourceDetailVec = iter->second;

	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivReservoirs::ReservoirsTable resTable;
		std::map<std::string, std::string> map = resultVector[i];

		std::string code = map.find("code")->second;
		std::string totalHead = map.find(restemTable.totalHead)->second;
		std::string Pattern = map.find(restemTable.headPattern)->second;

		for (int i = 0; i < resourceDetailVec.size(); i++)
		{
			std::map<std::string, std::string> detailMap = resourceDetailVec[i];


			//code ƥ䣬һѭ
			auto codeIter = detailMap.find("code");
			if (codeIter == detailMap.end())
				continue;

			// code ԭcode, 
			if (codeIter->second != code)
				continue;

			// ޸ĶӦֵ
			std::string attri = detailMap.find("")->second;
			std::string newValue = detailMap.find("ֵ")->second;
			if (attri == restemTable.totalHead)
			{
				totalHead = newValue;
			}
			else if (attri == restemTable.headPattern)
			{
				Pattern = newValue;
			}
		}
		resTable.ID = map.find(restemTable.sn)->second;
		resTable.Head = totalHead;
		resTable.Pattern = Pattern;

		reservoirs.addItem(resTable);
	}
	return true;
}

bool CivProjInpDbHelper::getCoordinates(CivCoordinates& coord)
{
	JunctionTable nodeTable;

	std::vector<std::string> fields;

	fields.push_back(nodeTable.sn);
	fields.push_back(nodeTable.xCoord);
	fields.push_back(nodeTable.yCoord);

	std::vector<std::map<std::string, std::string>> resultVector;


	std::string condition1 = splicingConditions(PIPENODE);
	mDbConn->query(PIPENODE, fields, resultVector, condition1);

	std::string condition2 = splicingConditions(TANK);
	mDbConn->query(TANK, fields, resultVector,condition2);

	std::string condition3 = splicingConditions(RESIVOIR);
	mDbConn->query(RESIVOIR, fields, resultVector, condition3);

	std::string condition = " \"\" = '"+mPorjCode+"'";
	mDbConn->query(PROJ_PIPENODE, fields, resultVector, condition);
	mDbConn->query(PROJ_TANK, fields, resultVector, condition);
	mDbConn->query(PROJ_RESIVOIR, fields, resultVector, condition);
	
	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivCoordinates::CoordTable coordTable;
		std::map<std::string, std::string> map = resultVector[i];

		coordTable.ID = map.find(fields[0])->second;
		coordTable.XCoord = map.find(fields[1])->second;
		coordTable.YCoord = map.find(fields[2])->second;

		coord.addItem(coordTable);
	}

	// 
	for (int i = 0; i < mCoords.size(); i++)
	{
		coord.addItem(mCoords[i]);
	}
	return true;
}

bool CivProjInpDbHelper::getQuality(CivQuality& quality)
{
	JunctionTable nodeTable;

	std::vector<std::string> fields; 

	fields.push_back(nodeTable.sn);
	fields.push_back(nodeTable.initQuality);
	
	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->query(PIPENODE, fields, resultVector);
	mDbConn->query(RESIVOIR, fields, resultVector);
	mDbConn->query(PROJ_PIPENODE, fields, resultVector, mCondition);
	mDbConn->query(PROJ_RESIVOIR, fields, resultVector, mCondition);
	
	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivQuality::QualityTable quliTable;

		std::map<std::string, std::string> map = resultVector[i];
		quliTable.ID = map.find(fields[0])->second;
		quliTable.InitQuality = map.find(fields[1])->second;;

		quality.addItem(quliTable);
	}

	return true;
}

bool CivProjInpDbHelper::getStatus(CivStatus& status)
{
	// ״̬
	for (int i = 0; i < mStatusVec.size(); i++)
	{
		status.addItem(mStatusVec[i]);
	}
	return true;
}

std::string CivProjInpDbHelper::genSql(const std::string& table)
{
	return "";
}

std::string CivProjInpDbHelper::genSqlView(
	const std::string& table,
	const std::string& projTable,
	const std::vector<std::string>& fieldsVec,
	const std::string& projCode)
{
	int total = fieldsVec.size();
	if (total <= 0)
		return "";

	std::string fields1;
	std::string fileds2;
	for (int i = 0; i < total; i++)
	{
		fields1.append("\""+fieldsVec[i]+"\"");
		fields1.append(",");

		fileds2.append("node.\""+ fieldsVec[i] +"\"");
		fileds2.append(",");
	}
	fields1 = fields1.substr(0, fields1.length() - 1);	
	fileds2 = fileds2.substr(0, fileds2.length() - 1);

	std::string sql = " SELECT  "+ fields1 +"  FROM \""+table+"\" EXCEPT SELECT "+fileds2+" FROM \""+ table +"\" as node,\"\" as  detail where  detail.\"ͼ\" = '" + table + "' and detail.\"\" = '"+ projCode +"' and  detail.\"\"=0 and node.code =detail.\"code\"";
	
	std::string sql2 = " SELECT " + fields1 + " FROM \""+projTable+"\" as tb WHERE tb.\"\"='"+ projCode +"'";


	return sql +" UNION "+ sql2;
}

std::string CivProjInpDbHelper::splicingSql(const std::string& rightTable, const std::string& demandName, const std::string& demandPattern)
{
	// sqlviewͼ
	std::vector<std::string> valveFiledVec;
	valveFiledVec.push_back("code");
	valveFiledVec.push_back("");
	valveFiledVec.push_back("");
	valveFiledVec.push_back("");
	valveFiledVec.push_back("̶״̬");
	valveFiledVec.push_back("");
	valveFiledVec.push_back("");
	valveFiledVec.push_back("ˮϵ");
	valveFiledVec.push_back("ʼڵ");
	valveFiledVec.push_back("ֹڵ");

	std::string valveView = genSqlView(TABLE_VALVE, PROJ_TABLE_VALVE, valveFiledVec, mPorjCode);

	// ܶsqlviewͼ
	std::vector<std::string> pipeFiledVec;
	pipeFiledVec.push_back("");
	pipeFiledVec.push_back("ܳ");
	pipeFiledVec.push_back("ܾ");
	pipeFiledVec.push_back("Ħϵ");
	pipeFiledVec.push_back("from_code");
	pipeFiledVec.push_back("to_code");
	pipeFiledVec.push_back("code");

	std::string pipeView = genSqlView(TABLE_PIPE, PROJ_TABLE_PIPE, pipeFiledVec, mPorjCode);

	std::string upcondition;
	std::string downcondition;

		// ڵsqlviewͼ
	std::vector<std::string> nodeFiledVec;
	nodeFiledVec.push_back("");
	nodeFiledVec.push_back("code");
	nodeFiledVec.push_back("߳");
	nodeFiledVec.push_back("ˮģʽ");
	nodeFiledVec.push_back("ˮ");
	nodeFiledVec.push_back("");
	nodeFiledVec.push_back("");
	nodeFiledVec.push_back("ʼˮ");
	std::string nodeView = genSqlView(TABLE_NODE, PROJ_TABLE_NODE, nodeFiledVec, mPorjCode);
	
	
	std::string otherView;
	if (rightTable == "ڵ")
	{
		upcondition = "pipe.\"from_code\" = node.\"code\"  AND pipe.\"to_code\" = junc.\"code\"";
		downcondition = "pipe.\"to_code\" = node.\"code\" AND pipe.\"from_code\" = junc.\"code\"";

		otherView = nodeView;	 
	}
	else
	{
		upcondition = "(pipe.\"to_code\" = node.\"code\"\
				AND pipe.\"from_code\" = junc.\"code\") or\
			(pipe.\"from_code\" = node.\"code\"\
				AND pipe.\"to_code\" = junc.\"code\")";

		downcondition = "(pipe.\"to_code\" = node.\"code\"\
				AND pipe.\"from_code\" = junc.\"code\") or\
			(pipe.\"from_code\" = node.\"code\"\
				AND pipe.\"to_code\" = junc.\"code\")";

		std::vector<std::string> otherFiledVec;
		otherFiledVec.push_back("");
		otherFiledVec.push_back("code");
		otherFiledVec.push_back("߳");
		otherFiledVec.push_back("");
		otherFiledVec.push_back("");
		otherFiledVec.push_back("ʼˮ");
		otherView = genSqlView(rightTable, "" + rightTable, otherFiledVec, mPorjCode);
	}
	

	std::string sql2 = "SELECT  A.*, B.*  FROM (SELECT\
			node.\"\",\
			node.\"\" AS ź,\
			node.\"\" AS ,\
			node.\"̶״̬\" AS Ź̶״̬,\
			node.\"\" AS ,\
			node.\"\" AS ,\
			node.\"ˮϵ\" AS ˮϵ,\
			pipe. AS ιܶα,\
			pipe.\"ܳ\" AS ιܳ,\
			pipe.\"ܾ\" AS ιܾ,\
			pipe.\"Ħϵ\" AS ιܶĦϵ,\
			junc.\"\" AS νڵ,\
			junc.\"code\" AS \"νڵcode\",\
			junc.\"߳\" AS νڵ߳,\
			" + demandPattern + " AS νڵˮģʽ,\
			" + demandName + "  AS νڵˮ,\
			junc.\"\" AS νڵ,\
			junc.\"\" AS νڵ,\
			junc.\"ʼˮ\" AS νڵʼˮ\
			FROM  ("+ valveView + ")node, ("+pipeView+") pipe,( " + otherView + ") junc\
			WHERE " + upcondition + ") A,\
		(\
			SELECT\
			pipe. AS ιܶα,\
			pipe.\"ܳ\" AS ιܶιܳ,\
			pipe.\"ܾ\" AS ιܶιܾ,\
			pipe.\"Ħϵ\" AS ιܶĦϵ,\
			node.\"\",\
			junc.\"\" AS νڵ,\
			junc.\"code\" AS \"νڵcode\",\
			junc.\"߳\" AS νڵ߳,\
			junc.\"ˮģʽ\" AS νڵˮģʽ,\
			junc.\"ˮ\" AS νڵˮ,\
			junc.\"\" AS νڵ,\
			junc.\"\" AS νڵ,\
			junc.\"ʼˮ\" AS νڵʼˮ\
			FROM  (" + valveView + ")node, (" + pipeView + ") pipe,(" + nodeView + ") junc\
			WHERE " + downcondition + ") B\
		WHERE\
		A.\"\" = b.\"\"";

	return sql2;
}

bool CivProjInpDbHelper::handleValves2()
{
	std::string sql = splicingSql("ڵ");

	if (!mDbConn->execSql(sql))
	{
		std::string error = mDbConn->getLastError();
		return false;
	}

	// ѯ뷧ŹĹܶΣͽڵ
	std::vector<std::map<std::string, std::string>> valvesPipes;
	mDbConn->queryResult(valvesPipes);

	// 
	std::string sql2 = splicingSql("ˮ", "0", "1");
	if (!mDbConn->execSql(sql2))
	{
		std::string error = mDbConn->getLastError();
		return false;
	}

	mDbConn->queryResult(valvesPipes);

	// ҳڵͼ޸ĵֵ
	std::vector<std::map<std::string, std::string>> valvesDetailVec;
	auto iter = mDetailMap.find("");
	if (iter != mDetailMap.end())
		valvesDetailVec = iter->second;

	// ܸ
	size_t total = valvesPipes.size();
	for (int i = 0; i < total; i++)
	{
		std::map<std::string, std::string> valvePipe = valvesPipes[i];

		std::string vaSzNo = valvePipe.find("")->second;
		std::string vaXcoord = valvePipe.find("ź")->second;
		std::string vaYcoord = valvePipe.find("")->second;
		std::string vaStatus = valvePipe.find("Ź̶״̬")->second;
		std::string vaType = valvePipe.find("")->second;
		std::string vaSetting = valvePipe.find("")->second;
		std::string vaLoss = valvePipe.find("ˮϵ")->second;
		std::string upperPipeSzNo = valvePipe.find("ιܶα")->second;
		std::string upperPipeCode = valvePipe.find("ιܶcode")->second;
		std::string upperPipeLength = valvePipe.find("ιܳ")->second;
		std::string upperPipeDiametor = valvePipe.find("ιܾ")->second;
		std::string upperPipeFriction = valvePipe.find("ιܶĦϵ")->second;
		std::string upperNodeSz = valvePipe.find("νڵ")->second;
		std::string upperNodeHeight = valvePipe.find("νڵ߳")->second;
		std::string upperNodePattern = valvePipe.find("νڵˮģʽ")->second;
		std::string upperNodeDemand = valvePipe.find("νڵˮ")->second;
		std::string upperNodeXcoord = valvePipe.find("νڵ")->second;
		std::string upperNodeYcoord = valvePipe.find("νڵ")->second;
		std::string upperNodeQuality = valvePipe.find("νڵʼˮ")->second;
		std::string donwPipeSz = valvePipe.find("ιܶα")->second;
		std::string donwPipeCode = valvePipe.find("ιܶcode")->second;
		std::string donwPipeLength = valvePipe.find("ιܶιܳ")->second;
		std::string donwPipeDiametor = valvePipe.find("ιܶιܾ")->second;
		std::string downPipeFraction = valvePipe.find("ιܶĦϵ")->second;
		std::string donwNodeSz = valvePipe.find("νڵ")->second;
		std::string donwNodeHeight = valvePipe.find("νڵ߳")->second;
		std::string donwNodePattern = valvePipe.find("νڵˮģʽ")->second;
		std::string donwNodeDemand = valvePipe.find("νڵˮ")->second;
		std::string donwNodeXcoord = valvePipe.find("νڵ")->second;
		std::string donwNodeYcoord = valvePipe.find("νڵ")->second;
		std::string donwNodeQuality = valvePipe.find("νڵʼˮ")->second;

		// жϷ
		std::string upperVaType = vaType;
		std::transform(vaType.begin(), vaType.begin(), vaType.end(), ::toupper);

		// Ҫڵ㣬ڵ㾡ܽӽ
		CivNode::NodeTable startNodeTable;
		CivCoordinates::CoordTable startNodeCoord; // ڵ

		// ڵϢ
		startNodeTable.ID = "VUP" + vaSzNo;
		startNodeTable.Elev = upperNodeHeight;
		startNodeTable.Demand = "0";

		// ֱ֮
		double vupperXcoord = (atof(upperNodeXcoord.c_str()) - atof(vaXcoord.c_str())) / 5 + atof(vaXcoord.c_str());
		double vupperYcoord = (atof(upperNodeYcoord.c_str()) - atof(vaYcoord.c_str())) / 5 + atof(vaYcoord.c_str());

		// ڵ
		startNodeCoord.ID = "VUP" + vaSzNo;
		startNodeCoord.XCoord = std::to_string(vupperXcoord);
		startNodeCoord.YCoord = std::to_string(vupperYcoord);

		// ֹڵ㹹
		CivNode::NodeTable endNodeTable; // ֹڵ
		CivCoordinates::CoordTable endNodeCoord; // ֹڵ

		// ֹڵϢ
		endNodeTable.ID = "VDW" + vaSzNo;
		endNodeTable.Elev = upperNodeHeight;
		endNodeTable.Demand = "0";

		mNodeVec.push_back(startNodeTable);
		mCoords.push_back(startNodeCoord);

		// ֱ֮
		double vdownXcoord = (atof(donwNodeXcoord.c_str()) - atof(vaXcoord.c_str())) / 5 + atof(vaXcoord.c_str());
		double vdownYcoord = (atof(donwNodeYcoord.c_str()) - atof(vaYcoord.c_str())) / 5 + atof(vaYcoord.c_str());

		// ֹڵϢ
		endNodeCoord.ID = "VDW" + vaSzNo;
		endNodeCoord.XCoord = std::to_string(vdownXcoord);
		endNodeCoord.YCoord = std::to_string(vdownYcoord);

		mNodeVec.push_back(endNodeTable);
		mCoords.push_back(endNodeCoord);

		// ιܶε
		CivPipe::PipesTable upperPipeTable;
		CivPipe::PipesTable downPipeTable;

		// ιܶ
		upperPipeTable.code = upperPipeCode;
		upperPipeTable.ID = upperPipeSzNo;
		upperPipeTable.Node1 = upperNodeSz;
		upperPipeTable.Node2 = startNodeTable.ID;
		upperPipeTable.Length = upperPipeLength;
		upperPipeTable.Diameter = upperPipeDiametor;
		upperPipeTable.Roughness = upperPipeFriction;
		upperPipeTable.Status = "Open";
		upperPipeTable.MinorLoss = vaLoss;

		// ιܶ
		downPipeTable.code = donwPipeCode;
		downPipeTable.ID = donwPipeSz;
		downPipeTable.Node1 = endNodeTable.ID;
		downPipeTable.Node2 = donwNodeSz;
		downPipeTable.Length = donwPipeLength;
		downPipeTable.Diameter = donwPipeDiametor;
		downPipeTable.Roughness = upperPipeFriction;
		downPipeTable.Status = "Open";
		downPipeTable.MinorLoss = vaLoss;

		mPipesVec.push_back(downPipeTable);
		mPipesVec.push_back(upperPipeTable);

		// ͨŵЧڹܶ
		if (upperVaType == "BV")
		{
			// һܶ
			CivPipe::PipesTable vPipeTable;
			vPipeTable.ID = "VG" + vaSzNo;
			vPipeTable.Node1 = startNodeTable.ID;
			vPipeTable.Node2 = endNodeTable.ID;
			vPipeTable.Length = donwPipeLength;
			vPipeTable.Diameter = donwPipeDiametor;
			vPipeTable.Roughness = upperPipeFriction;
			vPipeTable.Status = (vaStatus == "Close")?"CV":"Open";
			vPipeTable.MinorLoss = vaLoss;

			mPipesVec.push_back(vPipeTable);
		}
		else
		{
			// 
			CivValve::ValveTable valveTable;
			valveTable.ID = vaSzNo;
			valveTable.Node1 = startNodeTable.ID;
			valveTable.Node2 = endNodeTable.ID;
			valveTable.Diameter = upperPipeDiametor;
			valveTable.Type = vaType;
			valveTable.Setting = vaSetting;
			valveTable.MinorLoss = vaLoss;

			mValuvesVec.push_back(valveTable);

			// ״̬
			CivStatus::StatusTable statusTable;
			statusTable.ID = vaSzNo;
			statusTable.Setting = vaStatus;

			mStatusVec.push_back(statusTable);
		}
	}
}